package org.university.core;

import java.util.*;

public class Professor extends AbstractEmployee implements Account{
    private ArrayList<Course> courses;
    private String group;

    public Professor(String name, int entranceYear, int id){
        super(name, entranceYear, id);
        courses = new ArrayList<>();
        basicIncome = 7000;
        balance = 0;
    }

    public Statement checkout(){
        int amount = getCurrentIncome();
        balance += amount;
        Statement statement = new Statement(amount, new Date(), (Account)this);
        addBankStatement(statement);
        return statement;
    }

    public int getCurrentIncome(){
        return courses.size() * 1000 + basicIncome; 
    }

    public Course[] getCourses(){
        Course[] arr = new Course[courses.size()];
        courses.toArray(arr);
        
        return arr;
    }

    public void addCourse(Course c){
        courses.add(c);
    }

    public String getGroup(){
        return group;
    }

    public boolean isPromotable(){
        //TODO
        return true;
    }
}
